/**
 * ForEach.java
 *
 * File generated from the XValidator4::ForEach uml Class
 * Generated by IHE - europe, gazelle team
 */
package net.ihe.gazelle.xvalidation.core.model;

import junit.framework.Assert;
import junit.framework.AssertionFailedError;
import net.ihe.gazelle.xvalidation.core.exception.GazelleXValidationException;
import net.ihe.gazelle.xvalidation.core.report.Notification;
import net.ihe.gazelle.xvalidation.core.report.Report;
import net.ihe.gazelle.xvalidation.core.xpath.XpathUtils;
import net.sf.saxon.dom.DOMNodeList;
import org.w3c.dom.Node;

import javax.persistence.CascadeType;
import javax.persistence.DiscriminatorValue;
import javax.persistence.Entity;
import javax.persistence.JoinColumn;
import javax.persistence.OneToOne;
import javax.persistence.Transient;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlAttribute;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlElementRef;
import javax.xml.bind.annotation.XmlElementRefs;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlTransient;
import javax.xml.bind.annotation.XmlType;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;

// End of user code

/**
 * Description of the class ForEach.
 *
 */

@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "ForEach", propOrder = { "locator", "expressionSet", "var" })
@XmlRootElement(name = "ForEach")
@Entity
@DiscriminatorValue("forEach")
public class ForEach extends AbstractExpression {

	/**
	 *
	 */
	private static final long serialVersionUID = 1L;

	@XmlElementRefs({ @XmlElementRef(name = "Not", type = Not.class),
			@XmlElementRef(name = "InValueSet", type = InValueSet.class),
			@XmlElementRef(name = "Present", type = Present.class),
			@XmlElementRef(name = "LogicalOperation", type = LogicalOperation.class),
			@XmlElementRef(name = "BasicOperation", type = BasicOperation.class),
			@XmlElementRef(name = "ForEach", type = ForEach.class),
            @XmlElementRef(name = "MathComparison", type = MathComparison.class),
            @XmlElementRef(name = "True", type = True.class)})
	@OneToOne(cascade = { CascadeType.ALL })
	@JoinColumn(name = "expression_set_id")
	private AbstractExpression expressionSet;

	@XmlElement(name = "Locator", required = true)
	@OneToOne(cascade = { CascadeType.ALL })
	@JoinColumn(name = "locator_id")
	private Locator locator;

	@XmlAttribute(name = "var", required = true)
	private String var;

	public ForEach() {
		super();
		this.locator = new Locator();
	}

	public ForEach(ForEach exp){
		super();
		this.locator = new Locator(exp.getLocator());
		this.var = exp.getVar();
		this.expressionSet = exp.getExpressionSet().createCopy();
	}
	/**
	 * An attribute containing marshalled element node
	 */
	@XmlTransient
	@Transient
	private org.w3c.dom.Node xmlNodePresentation;

	@Override
	public Node getXmlNodePresentation() {
		if (xmlNodePresentation == null) {
			xmlNodePresentation = ObjectFactory.getXmlNodePresentation("", "ForEach", this);
		}
		return xmlNodePresentation;
	}

	public Locator getLocator() {
		return locator;
	}

	public void setLocator(Locator locator) {
		this.locator = locator;
	}

	@Override
	public void setXmlNodePresentation(Node xmlNodePresentation) {
		this.xmlNodePresentation = xmlNodePresentation;
	}

	public AbstractExpression getExpressionSet() {
		return expressionSet;
	}

	public void setExpressionSet(AbstractExpression expressionSet) {
		this.expressionSet = expressionSet;
	}

	public String getVar() {
		return var;
	}

	public void setVar(String var) {
		this.var = var;
	}

	@Override
	public Notification evaluate(Map<String, Node> files, ValidatorConfiguration configuration, Level level) {
		DOMNodeList nodes;
		StringBuilder xpathReport = new StringBuilder();
		try {
			nodes = XpathUtils.getNodesFromDOM(files.get(locator.getAppliesOn()), locator,
					configuration.getNamespaceContext());
		} catch (GazelleXValidationException e){
			return abort("Error evaluating XPath : " + e.getMessage(), locator, "Error evaluating XPath " + locator.toString() + " : " + e.getMessage());
		}
		xpathReport.append(XpathUtils.getXPathReport(locator, nodes));
		xpathReport.append("\nResults forEach :\n");

		boolean result = true;
		if (nodes.getLength() == 0){
			result = false;
		} else {
			for (int index = 0; index < nodes.getLength(); index++) {
				xpathReport.append("node " + (index+1) + " :\n");
				Node node = nodes.item(index);
				files.put(var, node);
				Notification notification = expressionSet.evaluate(files, configuration, level);
				xpathReport.append(notification.getXpathReport());
				if (!(notification instanceof Report)) {
					result = false;
				} else {
					continue;
				}
			}
		}
		Notification resultNotification;
		if (!result){
			resultNotification = newNotificationForLevel(level);
		} else {
			resultNotification = newNotificationForLevel(null);
		}
		resultNotification.setXpathReport(xpathReport.toString());
		return resultNotification;
	}

	@Override
	public String toString() {
		StringBuilder builder = new StringBuilder();
		builder.append(" for each (");
		builder.append(this.var);
		builder.append(" in ");
		builder.append(this.locator.toString());
		builder.append("){<br/>");
		builder.append(this.expressionSet.toString());
		builder.append("<br/>}");
		return builder.toString();
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = super.hashCode();
		result = (prime * result) + ((expressionSet == null) ? 0 : expressionSet.hashCode());
		result = (prime * result) + ((locator == null) ? 0 : locator.hashCode());
		result = (prime * result) + ((var == null) ? 0 : var.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj) {
			return true;
		}
		if (!super.equals(obj)) {
			return false;
		}
		if (getClass() != obj.getClass()) {
			return false;
		}
		ForEach other = (ForEach) obj;
		if (expressionSet == null) {
			if (other.expressionSet != null) {
				return false;
			}
		} else if (!expressionSet.equals(other.expressionSet)) {
			return false;
		}
		if (locator == null) {
			if (other.locator != null) {
				return false;
			}
		} else if (!locator.equals(other.locator)) {
			return false;
		}
		if (var == null) {
			if (other.var != null) {
				return false;
			}
		} else if (!var.equals(other.var)) {
			return false;
		}
		return true;
	}

	@Override
	public String getEditLink() {
		return "/xvalidation/expressions/forEach.xhtml";
	}

	@Override
	public void testCorrectness() throws AssertionFailedError {
		Assert.assertNotNull("[Expression #" + getFakeId() + "] Locator is null", locator);
		Assert.assertTrue("[Expression #" + getFakeId() + "] Locator is not correctly populated", locator.isValued());
		if (var == null || var.isEmpty()){
			var = "var";
		}
		Assert.assertNotNull("[Expression #" + getFakeId() + "] No expression defined", expressionSet);
		expressionSet.testCorrectness();
	}

	@Override
	public ArrayList<String> appliesTo() throws AssertionFailedError {
		ArrayList<String> keywords = new ArrayList<String>();
		testCorrectness();
		keywords.add(locator.getAppliesOn());
		List<String> keywordsFromExpressionSet = expressionSet.appliesTo();
		for (String keyword : keywordsFromExpressionSet){
			if (!keywords.contains(keyword)){
				keywords.add(keyword);
			}
		}
		// the variable's name used to loop over the result of the locator shall not appear in the list of keywords
		keywords.remove(this.var);
		return keywords;
	}

	@Override
	public AbstractExpression createCopy() {
		return new ForEach(this);
	}
}